<?php
/**
 * Created by PhpStorm.
 * User: jderosa
 * Date: 20/04/20
 * Time: 11.57
 */

namespace FiloBlu\Rma\Block\Returns;
use Magento\Framework\App\ProductMetadataInterface;

class Create extends \Magento\Rma\Block\Returns\Create
{
    /**
     * @var ProductMetadataInterface
     */
    private $productMetadata;

    const CREATE_TEMPLATE_MAGENTO_V2_3_X = 'FiloBlu_Rma::return/createv23x.phtml';

    /**
     * Create constructor.
     * @param \Magento\Framework\View\Element\Template\Context $context
     * @param \Magento\Framework\Data\Collection\ModelFactory $modelFactory
     * @param \Magento\Eav\Model\Form\Factory $formFactory
     * @param \Magento\Eav\Model\Config $eavConfig
     * @param \Magento\Rma\Model\ItemFactory $itemFactory
     * @param \Magento\Rma\Model\Item\FormFactory $itemFormFactory
     * @param \Magento\Rma\Helper\Data $rmaData
     * @param \Magento\Framework\Registry $registry
     * @param \Magento\Sales\Model\Order\Address\Renderer $addressRenderer
     * @param ProductMetadataInterface $productMetadata
     * @param array $data
     */
    public function __construct(
        \Magento\Framework\View\Element\Template\Context $context,
        \Magento\Framework\Data\Collection\ModelFactory $modelFactory,
        \Magento\Eav\Model\Form\Factory $formFactory,
        \Magento\Eav\Model\Config $eavConfig,
        \Magento\Rma\Model\ItemFactory $itemFactory,
        \Magento\Rma\Model\Item\FormFactory $itemFormFactory,
        \Magento\Rma\Helper\Data $rmaData,
        \Magento\Framework\Registry $registry,
        \Magento\Sales\Model\Order\Address\Renderer $addressRenderer,
        ProductMetadataInterface $productMetadata,
        array $data = [])
    {
        parent::__construct($context, $modelFactory, $formFactory, $eavConfig, $itemFactory, $itemFormFactory, $rmaData, $registry, $addressRenderer, $data);
        $this->productMetadata = $productMetadata;
    }

    /**
     * @param string $template
     * @return \Magento\Rma\Block\Returns\Create
     */
    public function setTemplate($template)
        {
            $magentoVersion = $this->productMetadata->getVersion();
            $magentoVersion = (int) str_replace(".","",$magentoVersion);
            if($magentoVersion >= 230){
              $template = self::CREATE_TEMPLATE_MAGENTO_V2_3_X;
            }
            return parent::setTemplate($template);
        }

}